---
title: Performance benchmarks
permalink: /performance/
relative_path: pages/performance.md
layout: page
noindex: true
sitemap: false
---

# {{ page.title }} for v1.0.0

These are the execution times for the current indicators using two years of historical daily stock quotes (502 periods) with default or typical parameters.

``` bash
pytest=v6.2.5, pytest-benchmark=v3.4.1 OS=macOS Monterey 12.5
Apple M1, 8 cores, MacBook Air (2020)
.NET 6
```

## Indicators

```bash
---------------------------------------------------------------------------------------- benchmark: 80 tests -----------------------------------------------------------------------------------------
Name (time in ms)                       Min                 Max               Mean             StdDev             Median               IQR            Outliers       OPS            Rounds  Iterations
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_benchmark_renko                 1.6574 (1.0)        2.9116 (1.06)      1.7372 (1.0)       0.1487 (1.77)      1.6745 (1.0)      0.1527 (1.19)          7;2  575.6399 (1.0)         122           1
test_benchmark_alma                  2.2150 (1.34)     100.7342 (36.54)     3.0028 (1.73)      7.4281 (88.19)     2.3214 (1.39)     0.1676 (1.31)          1;9  333.0242 (0.58)        176           1
test_benchmark_atr                   2.2681 (1.37)       4.4278 (1.61)      2.4105 (1.39)      0.2017 (2.39)      2.3537 (1.41)     0.1612 (1.26)          7;5  414.8504 (0.72)        170           1
test_benchmark_cci                   2.2790 (1.38)      78.7748 (28.57)     2.8302 (1.63)      5.7747 (68.56)     2.3547 (1.41)     0.1375 (1.07)          1;4  353.3327 (0.61)        175           1
test_benchmark_ema                   2.2878 (1.38)       3.5308 (1.28)      2.4223 (1.39)      0.1347 (1.60)      2.3707 (1.42)     0.1581 (1.23)         12;2  412.8352 (0.72)        167           1
test_benchmark_bollinger_bands       2.2922 (1.38)       2.8762 (1.04)      2.4209 (1.39)      0.1138 (1.35)      2.3737 (1.42)     0.1591 (1.24)         19;3  413.0619 (0.72)        127           1
test_benchmark_roc                   2.2967 (1.39)       3.0719 (1.11)      2.4182 (1.39)      0.1043 (1.24)      2.3598 (1.41)     0.1449 (1.13)         32;4  413.5305 (0.72)        219           1
test_benchmark_kama                  2.2972 (1.39)       2.9766 (1.08)      2.4010 (1.38)      0.0932 (1.11)      2.3451 (1.40)     0.1369 (1.07)         29;1  416.5006 (0.72)        167           1
test_benchmark_adx                   2.2991 (1.39)       7.4640 (2.71)      2.6088 (1.50)      0.7419 (8.81)      2.3662 (1.41)     0.1803 (1.40)        11;15  383.3144 (0.67)        133           1
test_benchmark_awesome               2.3002 (1.39)       3.7825 (1.37)      2.4455 (1.41)      0.1968 (2.34)      2.3569 (1.41)     0.1664 (1.30)          7;5  408.9095 (0.71)        152           1
test_benchmark_bop                   2.3007 (1.39)       5.5773 (2.02)      2.4551 (1.41)      0.3081 (3.66)      2.3665 (1.41)     0.1531 (1.19)          4;4  407.3194 (0.71)        128           1
test_benchmark_fisher_transform      2.3068 (1.39)       2.9399 (1.07)      2.4296 (1.40)      0.1022 (1.21)      2.3884 (1.43)     0.1406 (1.09)         38;3  411.5911 (0.72)        163           1
test_benchmark_adl                   2.3073 (1.39)       4.5819 (1.66)      2.4947 (1.44)      0.4462 (5.30)      2.3596 (1.41)     0.1675 (1.30)          1;1  400.8522 (0.70)         25           1
test_benchmark_chop                  2.3088 (1.39)       5.5838 (2.03)      2.4649 (1.42)      0.3084 (3.66)      2.3963 (1.43)     0.1622 (1.26)          5;5  405.6952 (0.70)        155           1
test_benchmark_pvo                   2.3103 (1.39)       3.0191 (1.10)      2.4365 (1.40)      0.1040 (1.23)      2.3733 (1.42)     0.1420 (1.11)         26;4  410.4295 (0.71)        183           1
test_benchmark_aroon                 2.3109 (1.39)       3.4798 (1.26)      2.4390 (1.40)      0.1487 (1.77)      2.3669 (1.41)     0.1595 (1.24)         10;3  410.0110 (0.71)        119           1
test_benchmark_rsi                   2.3112 (1.39)      80.4267 (29.17)     2.7055 (1.56)      4.6963 (55.76)     2.3680 (1.41)     0.1384 (1.08)          1;5  369.6239 (0.64)        276           1
test_benchmark_tsi                   2.3114 (1.39)       2.8353 (1.03)      2.4340 (1.40)      0.0931 (1.11)      2.3848 (1.42)     0.1380 (1.07)         34;2  410.8482 (0.71)        164           1
test_benchmark_chandelier            2.3118 (1.39)       4.4430 (1.61)      2.4570 (1.41)      0.2249 (2.67)      2.4018 (1.43)     0.1624 (1.26)          7;5  406.9989 (0.71)        173           1
test_benchmark_doji                  2.3243 (1.40)       3.5377 (1.28)      2.4787 (1.43)      0.1622 (1.93)      2.4180 (1.44)     0.1451 (1.13)         10;5  403.4309 (0.70)        102           1
test_benchmark_chaikin_osc           2.3295 (1.41)       3.1746 (1.15)      2.4619 (1.42)      0.1279 (1.52)      2.4050 (1.44)     0.1442 (1.12)         13;5  406.1895 (0.71)        117           1
test_benchmark_obv                   2.3298 (1.41)      81.4391 (29.54)     2.8933 (1.67)      5.6553 (67.14)     2.4447 (1.46)     0.1707 (1.33)          1;3  345.6280 (0.60)        195           1
test_benchmark_pmo                   2.3396 (1.41)       2.7571 (1.0)       2.4212 (1.39)      0.0904 (1.07)      2.3648 (1.41)     0.1377 (1.07)         21;2  413.0227 (0.72)        114           1
test_benchmark_alligator             2.3403 (1.41)       3.3640 (1.22)      2.4604 (1.42)      0.1788 (2.12)      2.3812 (1.42)     0.1555 (1.21)          4;3  406.4460 (0.71)         48           1
test_benchmark_fcb                   2.3442 (1.41)      79.5877 (28.87)     3.0080 (1.73)      6.4959 (77.12)     2.4180 (1.44)     0.1536 (1.20)          1;1  332.4459 (0.58)        141           1
test_benchmark_stdev                 2.3452 (1.42)      83.3521 (30.23)     2.9266 (1.68)      6.1871 (73.46)     2.4022 (1.43)     0.1374 (1.07)          1;3  341.6918 (0.59)        171           1
test_benchmark_t3                    2.3510 (1.42)      80.8448 (29.32)     3.0943 (1.78)      7.1580 (84.98)     2.3890 (1.43)     0.1466 (1.14)          1;3  323.1732 (0.56)        120           1
test_benchmark_sma                   2.3558 (1.42)       2.9725 (1.08)      2.4472 (1.41)      0.0880 (1.05)      2.3962 (1.43)     0.1431 (1.11)         64;2  408.6312 (0.71)        309           1
test_benchmark_trix                  2.3574 (1.42)       2.9425 (1.07)      2.4540 (1.41)      0.0971 (1.15)      2.3956 (1.43)     0.1417 (1.10)         20;2  407.4902 (0.71)        152           1
test_benchmark_kvo                   2.3624 (1.43)       2.8862 (1.05)      2.4441 (1.41)      0.0959 (1.14)      2.3845 (1.42)     0.1416 (1.10)         22;2  409.1435 (0.71)        149           1
test_benchmark_ma_envelopes          2.3632 (1.43)       5.2028 (1.89)      2.5352 (1.46)      0.2558 (3.04)      2.4683 (1.47)     0.1749 (1.36)          6;5  394.4426 (0.69)        166           1
test_benchmark_connors_rsi           2.3636 (1.43)       2.8833 (1.05)      2.4698 (1.42)      0.0996 (1.18)      2.4412 (1.46)     0.1469 (1.14)         24;2  404.8920 (0.70)         97           1
test_benchmark_pivot_points          2.3643 (1.43)       4.1478 (1.50)      2.5004 (1.44)      0.2320 (2.75)      2.4003 (1.43)     0.1692 (1.32)          7;5  399.9437 (0.69)         95           1
test_benchmark_vwap                  2.3645 (1.43)      80.5228 (29.21)     2.9154 (1.68)      5.8846 (69.87)     2.4138 (1.44)     0.1399 (1.09)          1;6  343.0118 (0.60)        176           1
test_benchmark_smi                   2.3650 (1.43)       2.9602 (1.07)      2.4737 (1.42)      0.1039 (1.23)      2.4117 (1.44)     0.1499 (1.17)         33;4  404.2494 (0.70)        189           1
test_benchmark_cmf                   2.3655 (1.43)       5.6912 (2.06)      2.5735 (1.48)      0.4231 (5.02)      2.4382 (1.46)     0.1601 (1.25)          6;9  388.5783 (0.68)        124           1
test_benchmark_parabolic_sar         2.3657 (1.43)       3.0547 (1.11)      2.4655 (1.42)      0.1207 (1.43)      2.3993 (1.43)     0.1434 (1.12)          9;4  405.5975 (0.70)         96           1
test_benchmark_wma                   2.3691 (1.43)      82.8252 (30.04)     2.7480 (1.58)      4.7440 (56.32)     2.4205 (1.45)     0.1320 (1.03)          1;3  363.9008 (0.63)        287           1
test_benchmark_mfi                   2.3712 (1.43)       2.9429 (1.07)      2.4684 (1.42)      0.1015 (1.21)      2.4113 (1.44)     0.1552 (1.21)         35;3  405.1242 (0.70)        182           1
test_benchmark_macd                  2.3765 (1.43)      80.1003 (29.05)     2.9267 (1.68)      5.7851 (68.68)     2.4489 (1.46)     0.1469 (1.14)          1;2  341.6786 (0.59)        180           1
test_benchmark_sma_extended          2.3789 (1.44)       2.7619 (1.00)      2.4721 (1.42)      0.0898 (1.07)      2.4286 (1.45)     0.1371 (1.07)         43;2  404.5174 (0.70)        176           1
test_benchmark_dema                  2.3858 (1.44)      89.1584 (32.34)     2.9747 (1.71)      6.4423 (76.49)     2.4450 (1.46)     0.1329 (1.04)          1;5  336.1727 (0.58)        181           1
test_benchmark_williams_r            2.3876 (1.44)       3.0262 (1.10)      2.5240 (1.45)      0.1161 (1.38)      2.4687 (1.47)     0.1647 (1.28)         28;7  396.1930 (0.69)        206           1
test_benchmark_fractal               2.3929 (1.44)       3.8272 (1.39)      2.4967 (1.44)      0.1390 (1.65)      2.4344 (1.45)     0.1493 (1.16)          8;5  400.5241 (0.70)        225           1
test_benchmark_mama                  2.3934 (1.44)       2.8937 (1.05)      2.4918 (1.43)      0.1061 (1.26)      2.4326 (1.45)     0.1480 (1.15)         16;3  401.3095 (0.70)        121           1
test_benchmark_stoch_rsi             2.3935 (1.44)       2.9751 (1.08)      2.5042 (1.44)      0.1105 (1.31)      2.4457 (1.46)     0.1574 (1.23)         20;3  399.3249 (0.69)        175           1
test_benchmark_smma                  2.3958 (1.45)       3.2075 (1.16)      2.5307 (1.46)      0.1039 (1.23)      2.4744 (1.48)     0.1353 (1.05)         33;4  395.1528 (0.69)        219           1
test_benchmark_ultimate              2.3990 (1.45)       2.9825 (1.08)      2.4842 (1.43)      0.0998 (1.18)      2.4246 (1.45)     0.1350 (1.05)         27;4  402.5472 (0.70)        200           1
test_benchmark_stc                   2.3996 (1.45)       3.1454 (1.14)      2.5116 (1.45)      0.1213 (1.44)      2.4653 (1.47)     0.1608 (1.25)         11;2  398.1598 (0.69)        109           1
test_benchmark_stoch                 2.4093 (1.45)       2.9539 (1.07)      2.5376 (1.46)      0.1040 (1.24)      2.5027 (1.49)     0.1581 (1.23)         93;1  394.0661 (0.68)        239           1
test_benchmark_marubozu              2.4095 (1.45)       3.3918 (1.23)      2.5241 (1.45)      0.1145 (1.36)      2.4693 (1.47)     0.1689 (1.32)         28;1  396.1766 (0.69)        177           1
test_benchmark_stdev_channels        2.4112 (1.45)       2.8950 (1.05)      2.5070 (1.44)      0.0934 (1.11)      2.4537 (1.47)     0.1374 (1.07)         27;3  398.8835 (0.69)        158           1
test_benchmark_super_trend           2.4119 (1.46)       3.0564 (1.11)      2.5233 (1.45)      0.1110 (1.32)      2.4727 (1.48)     0.1606 (1.25)         18;4  396.3103 (0.69)        161           1
test_benchmark_elder_ray             2.4223 (1.46)       3.0174 (1.09)      2.5726 (1.48)      0.1263 (1.50)      2.5263 (1.51)     0.1897 (1.48)         56;2  388.7095 (0.68)        176           1
test_benchmark_starc_bands           2.4313 (1.47)       3.1210 (1.13)      2.5548 (1.47)      0.1060 (1.26)      2.4951 (1.49)     0.1508 (1.17)         20;3  391.4268 (0.68)        172           1
test_benchmark_keltner               2.4362 (1.47)       3.1095 (1.13)      2.5443 (1.46)      0.1087 (1.29)      2.4789 (1.48)     0.1492 (1.16)         21;4  393.0330 (0.68)        169           1
test_benchmark_force_index           2.4365 (1.47)       3.2284 (1.17)      2.5585 (1.47)      0.1299 (1.54)      2.5013 (1.49)     0.1577 (1.23)         20;5  390.8616 (0.68)        188           1
test_benchmark_vwma                  2.4365 (1.47)       2.8986 (1.05)      2.5792 (1.48)      0.0842 (1.0)       2.5394 (1.52)     0.1368 (1.06)         49;2  387.7195 (0.67)        202           1
test_benchmark_ulcer_index           2.4420 (1.47)       3.2003 (1.16)      2.5314 (1.46)      0.1008 (1.20)      2.4760 (1.48)     0.1482 (1.15)         28;2  395.0457 (0.69)        193           1
test_benchmark_epma                  2.4434 (1.47)       3.1662 (1.15)      2.5874 (1.49)      0.1216 (1.44)      2.5412 (1.52)     0.1532 (1.19)         16;5  386.4916 (0.67)        125           1
test_benchmark_volatility_stop       2.4436 (1.47)       3.3951 (1.23)      2.5816 (1.49)      0.1314 (1.56)      2.5321 (1.51)     0.1525 (1.19)         11;3  387.3525 (0.67)        131           1
test_benchmark_triple_ema            2.4493 (1.48)       3.0130 (1.09)      2.5362 (1.46)      0.0871 (1.03)      2.4896 (1.49)     0.1338 (1.04)         30;1  394.2839 (0.68)        165           1
test_benchmark_slope                 2.4632 (1.49)       3.0468 (1.11)      2.5905 (1.49)      0.0902 (1.07)      2.5469 (1.52)     0.1435 (1.12)         55;1  386.0306 (0.67)        243           1
test_benchmark_dpo                   2.4793 (1.50)       3.7378 (1.36)      2.5963 (1.49)      0.1816 (2.16)      2.5243 (1.51)     0.1498 (1.17)          4;4  385.1707 (0.67)        106           1
test_benchmark_pivots                2.4882 (1.50)       3.2399 (1.18)      2.5847 (1.49)      0.1194 (1.42)      2.5226 (1.51)     0.1497 (1.17)          7;1  386.8849 (0.67)         83           1
test_benchmark_vortex                2.4892 (1.50)       3.0696 (1.11)      2.5769 (1.48)      0.0958 (1.14)      2.5188 (1.50)     0.1426 (1.11)         31;3  388.0655 (0.67)        197           1
test_benchmark_gator                 2.4901 (1.50)       5.7731 (2.09)      2.7010 (1.55)      0.3141 (3.73)      2.6349 (1.57)     0.1664 (1.30)          4;4  370.2336 (0.64)        128           1
test_benchmark_ht_trendline          2.4928 (1.50)       2.9470 (1.07)      2.6085 (1.50)      0.0959 (1.14)      2.5479 (1.52)     0.1440 (1.12)         23;3  383.3572 (0.67)        136           1
test_benchmark_zig_zag               2.5178 (1.52)       3.3415 (1.21)      2.6219 (1.51)      0.1397 (1.66)      2.5546 (1.53)     0.1397 (1.09)          4;3  381.4100 (0.66)         67           1
test_benchmark_heikin_ashi           2.5945 (1.57)       4.3157 (1.57)      2.7219 (1.57)      0.1855 (2.20)      2.6529 (1.58)     0.1374 (1.07)          7;4  367.3922 (0.64)        123           1
test_benchmark_hma                   2.6085 (1.57)       4.4372 (1.61)      2.7884 (1.61)      0.2108 (2.50)      2.7178 (1.62)     0.1473 (1.15)          4;4  358.6259 (0.62)         88           1
test_benchmark_donchian              2.6484 (1.60)       4.1639 (1.51)      2.8026 (1.61)      0.1870 (2.22)      2.7318 (1.63)     0.1284 (1.0)           9;9  356.8058 (0.62)        126           1
test_benchmark_rolling_pivots        2.6973 (1.63)       4.9203 (1.78)      2.8241 (1.63)      0.2128 (2.53)      2.7466 (1.64)     0.1479 (1.15)          6;2  354.0989 (0.62)        132           1
test_benchmark_hurst                 3.0476 (1.84)       5.7539 (2.09)      3.2309 (1.86)      0.2391 (2.84)      3.1924 (1.91)     0.1658 (1.29)          4;3  309.5102 (0.54)        143           1
test_benchmark_ichimoku              3.5423 (2.14)       5.6993 (2.07)      3.7514 (2.16)      0.2454 (2.91)      3.6555 (2.18)     0.1933 (1.51)          5;2  266.5680 (0.46)         91           1
test_benchmark_prs                   3.6014 (2.17)       4.1990 (1.52)      3.7929 (2.18)      0.1082 (1.29)      3.8066 (2.27)     0.1549 (1.21)         43;2  263.6498 (0.46)        145           1
test_benchmark_beta                  3.6362 (2.19)      12.5349 (4.55)      4.0685 (2.34)      1.0775 (12.79)     3.8554 (2.30)     0.1309 (1.02)         5;11  245.7928 (0.43)         83           1
test_benchmark_correlation           3.8193 (2.30)       4.5277 (1.64)      4.0095 (2.31)      0.1054 (1.25)      4.0256 (2.40)     0.1355 (1.06)         33;3  249.4049 (0.43)        151           1
test_benchmark_sma_longlong         56.3126 (33.98)    139.2124 (50.49)    67.8480 (39.06)    28.8469 (342.49)   57.8083 (34.52)    1.4496 (11.29)         1;1   14.7388 (0.03)          8           1
test_benchmark_hurst_longlong       75.6801 (45.66)    155.7022 (56.47)    88.4392 (50.91)    29.7009 (352.63)   76.9725 (45.97)    3.3941 (26.43)         1;1   11.3072 (0.02)          7           1
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Legend:
  Outliers: 1 Standard Deviation from Mean; 1.5 IQR (InterQuartile Range) from 1st Quartile and 3rd Quartile.
  OPS: Operations Per Second, computed as 1 / Mean
```
